#pragma comment (linker, "/STACK:1073741824")
#define _USE_MATH_DEFINES
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <fstream>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <vector>
#include <string>
#include <bitset>
#include <complex>
 
using namespace std;
 
#define SZ(x) (int((x).size()))
#define FOR(i, a, b) for(int (i) = (a); (i) <= (b); ++(i))
#define ROF(i, a, b) for(int (i) = (a); (i) >= (b); --(i))
#define REP(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define REPD(i, n) for (int (i) = (n); (i)--; )
#define FE(i, a) for (int (i) = 0; (i) < (int((a).size())); ++(i))
#define MEM(a, val) memset((a), val, sizeof(a))
#define INF 1000000000
#define LLINF 1000000000000000000LL
#define PB push_back
#define PPB pop_back
#define ALL(c) (c).begin(), (c).end()
#define SQR(a) ((a)*(a))
#define MP(a,b) make_pair((a), (b))
#define XX first
#define YY second
#define GET_RUNTIME_ERROR *(int*)(NULL) = 1
 
typedef vector<int> vint;
typedef vector<long long> vLL;
typedef double dbl;
typedef long double ldbl;
typedef vector<pair<int, int> > vpii;
typedef long long LL;
typedef pair<int, int> pii;
 
const int nmax = 100100;
 
int a[nmax];
int b[nmax];
int f[nmax];
 
void upd(int i, int d) {
  for(; i < nmax; i |= i + 1) f[i] += d;
}
 
int sum(int i) {
  int res = 0;
  for(; i >= 0; i = (i & (i + 1)) - 1) res += f[i];
  return res;
}
 
void solve() {
  MEM(a, 0);
  MEM(b, 0);
  MEM(f, 0);
 
  int n, m;
  cin >> n >> m;
  REP(i, n) scanf("%d", a + i);
  REP(i, m) scanf("%d", b + i);
 
  LL ansA = 0;
  REP(i, n) {
    ansA += i - sum(a[i]);
    upd(a[i], +1);
  }
 
  LL ansB = 0;
  MEM(f, 0);
  sort(b, b + m);
  for(int i = 0; i < m; ) {
    int j = i;
    while(j < m && b[i] == b[j]) ++j;
    ansB += (j - i)*LL(i);
    i = j;
  }
 
  REP(i, m)
    upd(b[i], +1);
 
  double ans = 0.0;
  REP(i, n) {
    int b = m - sum(a[i]);
    int g = sum(a[i] - 1);
    ans += (i + 1)/(n + 1.0)*b;
    ans += (n - i)/(n + 1.0)*g;
  }
 
  printf("%.9lf\n", ansA + ans + ansB/2.0);
}
int main() {
#ifdef    CENADAR_DEBUG
  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);
//  freopen("errput.txt", "w", stderr);
#else  // CENADAR_DEBUG
//  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);
#endif // CENADAR_DEBUG
 
  int T;
  cin >> T;
  while(T--) {
    solve();
  }
 
  return 0;
}
 